// ComGuidFinderDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ComGuidFinder.h"
#include "ComGuidFinderDlg.h"
#include "atlconv.h"
#include "comdef.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CComGuidFinderDlg dialog

CComGuidFinderDlg::CComGuidFinderDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CComGuidFinderDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CComGuidFinderDlg)
	m_chkDropOne = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CComGuidFinderDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CComGuidFinderDlg)
	DDX_Control(pDX, IDC_LI_IDS, m_CtlResultList);
	DDX_Check(pDX, IDC_DROP_ONE, m_chkDropOne);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CComGuidFinderDlg, CDialog)
	//{{AFX_MSG_MAP(CComGuidFinderDlg)
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	ON_MESSAGE(WM_DROPFILES,OnDropFiles)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CComGuidFinderDlg message handlers

BOOL CComGuidFinderDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	DragAcceptFiles(true);

	m_CtlResultList.InsertColumn(0,"Name",LVCFMT_LEFT,170);
	m_CtlResultList.InsertColumn(1,"Value",LVCFMT_LEFT,260);


	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}



// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CComGuidFinderDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.


BOOL CComGuidFinderDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{
	switch(wParam)
	{
		case ID_FILE_EXIT:
			CDialog::OnOK();
			break;
		case ID_FILE_ABOUT:
			CAboutDlg oDlg;
			oDlg.DoModal();
			break;

	}

	return CDialog::OnCommand(wParam, lParam);
}

void CComGuidFinderDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	// This is to moving the Dialog by clicking any where on the dialog
	PostMessage(WM_NCLBUTTONDOWN,HTCAPTION,MAKELPARAM(point.x,point.y));

}




LRESULT CComGuidFinderDlg::OnDropFiles(WPARAM wParam, LPARAM lParam)
{
	char	szDroppedFile[MAX_PATH];
	HDROP	hDrop ;
	int nFiles;
	CString csString;

	hDrop = (HDROP)wParam;
	UpdateData();
	m_CtlResultList.DeleteAllItems();
	if(!m_chkDropOne)
	{

		nFiles = DragQueryFile(hDrop,		// Struture Identifier
					  -1,			// -1 to Drop more than one file
					  szDroppedFile,// Droped File Name
					  MAX_PATH);	// Max char

		for(int i=0;i<nFiles;i++)
		{
			DragQueryFile(hDrop,i,szDroppedFile,MAX_PATH);
			m_CtlResultList.InsertItem(i,szDroppedFile);
		}
		csString.Format("Number of Dropped File(s) : %d",i);
	}
	else
	{
		nFiles = DragQueryFile(hDrop,		// Struture Identifier
					  0,			// -1 to Drop more than one file
					  szDroppedFile,// Droped File Name
					  MAX_PATH);
		m_CtlResultList.InsertItem(0,szDroppedFile);
		csString = "Number of Droppped File : 1";

	}
	GetDlgItem(IDC_FILE_PATH)->SetWindowText(csString);
	return 0;

}
